FPUFix PROC

	push	eax		;reserve space on CPU stack
	fstcw	[esp]		;get current control word
	fwait
	mov	ax,[esp]
	or	ax,0C00h	;code it for truncating
	push	eax
	fldcw	[esp]		;change rounding code of FPU to truncate

	frndint			;st=fix(x)

	pop	eax		;remove modified CW from CPU stack
	fldcw	[esp]		;load back the former control word
	fwait
	pop	eax		;clean CPU stack

	ret

FPUFix ENDP