FPUKepler PROC

	fld	eccent			;st=eccent,st(1)=m
	fld	st(1)			;st=e,st(1)=eccent,st(2)=m

FPUKepler00000:

	fld	st			;st=e,st(1)=e,st(2)=eccent,st(3)=m
	fsincos				;st=cos(e),st(1)=sin(e),st(2)=e,st(3)=eccent,st(4)=m
	fmul	st,st(3)		;st=eccent*cos(e),st(1)=sin(e),st(2)=e,st(3)=eccent,st(4)=m
	fxch				;st=sin(e),st(1)=eccent*cos(e),st(2)=e,st(3)=eccent,st(4)=m
	fmul	st,st(3)		;st=eccent*sin(e),st(1)=eccent*cos(e),st(2)=e,st(3)=eccent,st(4)=m
	fsubr	st,st(2)		;st=e-eccent*sin(e),st(1)=eccent*cos(e),st(2)=e,st(3)=eccent,st(4)=m
	fsub	st,st(4)		;st=delta=e-eccent*sin(e)-m,st(1)=eccent*cos(e),st(2)=e,st(3)=eccent,st(4)=m
	fxch				;st=eccent*cos(e),st(1)=delta,st(2)=e,st(3)=eccent,st(4)=m
	fld1				;st=1.0,st(1)=eccent*cos(e),st(2)=delta,st(3)=e,st(4)=eccent,st(5)=m
	fsubr				;st=1.0-eccent*cos(e),st(1)=delta,st(2)=e,st(3)=eccent,st(4)=m
	fdivr	st,st(1)		;st=delta/(1.0-eccent*cos(e)),st(1)=delta,st(2)=e,st(3)=eccent,st(4)=m
	fsubp	st(2),st		;st=delta,st(1)=e=e-delta/(1.0-eccent*cos(e)),st(2)=eccent,st(3)=m
	fabs				;st=|delta|,st(1)=e,st(2)=eccent,st(3)=m
	fcomp	EPSILON			;st=e,st(1)=eccent,st(2)=m

	fstsw	ax			;retrieve exception flags from FPU
	fwait
	sahf                    	;transfer to the CPU flags
	jz	FPUKepler00086

	jnc	FPUKepler00000

FPUKepler00086:

	ret

FPUKepler ENDP