.386
.model flat,stdcall
option casemap:none

include		\masm32\include\WINDOWS.inc
include		\LEMKE\MyInterFaces.inc

TASK_SUNDAY		equ	01h
TASK_MONDAY		equ	02h
TASK_TUESDAY		equ	03h
TASK_WEDNESDAY		equ	04h
TASK_THURSDAY		equ	05h
TASK_FRIDAY		equ	06h
TASK_SATURDAY		equ	07h
TASK_FIRST_WEEK		equ	01h
TASK_SECOND_WEEK	equ	02h
TASK_THIRD_WEEK		equ	03h
TASK_FOURTH_WEEK	equ	04h
TASK_LAST_WEEK		equ	05h
TASK_JANUARY		equ	01h
TASK_FEBRUARY		equ	02h
TASK_MARCH		equ	03h
TASK_APRIL		equ	04h
TASK_MAY		equ	05h
TASK_JUNE		equ	06h
TASK_JULY		equ	07h
TASK_AUGUST		equ	08h
TASK_SEPTEMBER		equ	09h
TASK_OCTOBER		equ	0Ah
TASK_NOVEMBER		equ	0Bh
TASK_DECEMBER		equ	0Ch

TASK_FLAG_INTERACTIVE			equ	01h
TASK_FLAG_DELETE_WHEN_DONE		equ	02h
TASK_FLAG_DISABLED			equ	04h
TASK_FLAG_START_ONLY_IF_IDLE		equ	010h
TASK_FLAG_KILL_ON_IDLE_END		equ	020h
TASK_FLAG_DONT_START_IF_ON_BATTERIES	equ	040h
TASK_FLAG_KILL_IF_GOING_ON_BATTERIES	equ	080h
TASK_FLAG_RUN_ONLY_IF_DOCKED		equ	0100h
TASK_FLAG_HIDDEN			equ	0200h
TASK_FLAG_RUN_IF_CONNECTED_TO_INTERNET	equ	0400h
TASK_FLAG_RESTART_ON_IDLE_RESUME	equ	0800h
TASK_FLAG_SYSTEM_REQUIRED		equ	01000h
TASK_FLAG_RUN_ONLY_IF_LOGGED_ON		equ	02000h
TASK_TRIGGER_FLAG_HAS_END_DATE		equ	01h
TASK_TRIGGER_FLAG_KILL_AT_DURATION_END	equ	02h
TASK_TRIGGER_FLAG_DISABLED		equ	04h

TASK_MINUTES_DURATION	equ	05A0h			;24 Hours
TASK_MAX_RUN_TIME	equ	259200000		;72 Hours

DAILY STRUCT 
	DaysInterval	WORD ? 
DAILY ENDS 

WEEKLY STRUCT 
	WeeksInterval		WORD ? 
	rgfDaysOfTheWeek	WORD ? 
WEEKLY ENDS 

MONTHLYDATE STRUCT 
	rgfDays		DWORD ? 
	rgfMonths	WORD ? 
MONTHLYDATE ENDS 

MONTHLYDOW STRUCT 
	wWhichWeek		WORD ? 
	rgfDaysOfTheWeek	WORD ? 
	rgfMonths		WORD ? 
MONTHLYDOW ENDS 

TRIGGER_TYPE_UNION UNION 4
	Daily		DAILY <> 
	Weekly		WEEKLY <> 
	MonthlyDate	MONTHLYDATE <> 
	MonthlyDOW	MONTHLYDOW <> 
TRIGGER_TYPE_UNION ENDS 

;EnumType : _TASK_TRIGGER_TYPE 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
TASK_TRIGGER_TYPE	TYPEDEF	DWORD

TASK_TIME_TRIGGER_ONCE			EQU 0 
TASK_TIME_TRIGGER_DAILY			EQU 1 
TASK_TIME_TRIGGER_WEEKLY		EQU 2 
TASK_TIME_TRIGGER_MONTHLYDATE		EQU 3 
TASK_TIME_TRIGGER_MONTHLYDOW		EQU 4 
TASK_EVENT_TRIGGER_ON_IDLE		EQU 5 
TASK_EVENT_TRIGGER_AT_SYSTEMSTART	EQU 6 
TASK_EVENT_TRIGGER_AT_LOGON		EQU 7 

TASK_TRIGGER STRUCT 
	cbTriggerSize		WORD ? 
	Reserved1		WORD ? 
	wBeginYear		WORD ? 
	wBeginMonth		WORD ? 
	wBeginDay		WORD ? 
	wEndYear		WORD ? 
	wEndMonth		WORD ? 
	wEndDay			WORD ? 
	wStartHour		WORD ? 
	wStartMinute		WORD ? 
	MinutesDuration		DWORD ? 
	MinutesInterval		DWORD ? 
	rgFlags			DWORD ? 
	TriggerType		TASK_TRIGGER_TYPE ? 
	Type0			TRIGGER_TYPE_UNION <> 
	Reserved2		WORD ? 
	wRandomMinutesInterval	WORD ? 
TASK_TRIGGER ENDS 

include		\masm32\include\kernel32.inc
include		\masm32\include\user32.inc
include		\masm32\include\gdi32.inc
include		\masm32\include\shell32.inc
include		\masm32\include\advapi32.inc
include		\masm32\include\ole32.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\gdi32.lib
includelib	\masm32\lib\shell32.lib
includelib	\masm32\lib\advapi32.lib
includelib	\masm32\lib\ole32.lib

WinMain		PROTO :DWORD,:DWORD,:DWORD,:DWORD

MoonPhaseCalculator	PROTO
SystemTimetoJulianDay	PROTO
JulianMoonPhase		PROTO
MoonPhaseHunt		PROTO
MeanPhase		PROTO
TruePhase		PROTO
JulianDaytoSystemTime	PROTO
JulianDaytoCalendar	PROTO
JulianDaytoDayofWeek	PROTO
JulianDaytoHourMinSec	PROTO
JulianDaytoASCII	PROTO
SystemTimetoASCII	PROTO :DWORD,:DWORD
MoonAgetoASCII		PROTO
MoonPhasetoASCII	PROTO
MoonDisttoASCII		PROTO
AngDiatoASCII		PROTO
SunDisttoASCII		PROTO
MoonPhaseInfoDisplay	PROTO :DWORD
FPUFloor		PROTO
FPUFix			PROTO
FPUFixAngle		PROTO
FPUDegtoRad		PROTO
FPUKepler		PROTO
FPUTan			PROTO
FPURadtoDeg		PROTO
FPURound		PROTO
FPUArcsin		PROTO
DrawMoon		PROTO :DWORD
Julian			PROTO :DWORD,:DWORD,:DWORD,:DWORD
UniversalTime		PROTO :DWORD,:DWORD,:DWORD,:DWORD
ASCIItoREAL		PROTO :DWORD
JulianTimetoASCII	PROTO
MoonPhaseBack		PROTO
MoonPhaseBitmap		PROTO
MoonPhaseBlack		PROTO :DWORD,:DWORD,:DWORD
MoonPhaseWhite		PROTO :DWORD,:DWORD,:DWORD
MoonPhaseIcon		PROTO

DWORDtoASCII		PROTO

.data

include		\LEMKE\Pics\FullMoonbmp.asm
include		\LEMKE\Pics\FullMoonMaskbmp.asm

;################################################################################
;#			Astronomical constants					#
;################################################################################
epoch		REAL8	2444238.5	;1980 January 0.0
;================================================================================

;################################################################################
;#		Constants defining the Sun's apparent orbit			#
;################################################################################
elonge		REAL8	278.833540	;Ecliptic longitude of the Sun at epoch 1980.0
elongp		REAL8	282.596403	;Ecliptic longitude of the Sun at perigee
eccent		REAL4	0.016718	;Eccentricity of Earth's orbit
sunsmax		REAL4	1.495985e8	;Semi-major axis of Earth's orbit, km
sunangsiz	REAL4	0.533128	;Sun's angular size, degrees, at semi-major axis distance
;================================================================================

;################################################################################
;#		Elements of the Moon's orbit, epoch 1980.0			#
;################################################################################
mmlong		REAL8	64.975464	;Moon's mean longitude at the epoch
mmlongp		REAL8	349.383063	;Mean longitude of the perigee at the epoch
;mlnode		REAL8	151.950429	;Mean longitude of the node at the epoch
;minc		REAL4	5.145396	;Inclination of the Moon's orbit
mecc		REAL4	0.054900	;Eccentricity of the Moon's orbit
mangsiz		REAL4	0.5181		;Moon's angular size at distance a from Earth
msmax		REAL4	384401.0	;Semi-major axis of Moon's orbit in km
;mparallax	REAL4	0.9507		;Parallax at distance a from Earth
synmonth	REAL8	29.5305873148148;Synodic month (new Moon to new Moon)
;lunatbase	REAL4	2423436.0	;Base date for E. W. Brown's numbered series of lunations (1923 January 16)
;================================================================================

EPSILON					REAL4	1.0E-6
Onehundredth				REAL4	0.01
Onetenth				REAL4	0.1
Elevenhundredths			REAL4	0.1114041
OneEighth				REAL4	0.125
Eightteenhundredths			REAL4	0.1858
TwentyOnehundredths			REAL4	0.214
ThirtySevenhundredths			REAL4	0.37
Half					REAL4	0.5
SixtyFivehundredths			REAL4	0.6583
One_Twotenths				REAL4	1.2739
One_Half				REAL4	1.5
MilesperKm				REAL4	1.609347
Four					REAL4	4.0
Six_TwentyEighthundredths		REAL4	6.2886
Thirteen_Seventeenhundredths		REAL8	13.1763966
Fifteen_Half				REAL4	15.5
Sixteen					REAL4	16.0
Thirty_Sixtenth				REAL4	30.6001
Sixty					REAL4	60.0
Onehundred				REAL4	100.0
OneTwentyTwo_Onetenth			REAL4	122.1
OneEighty				REAL4	180.0
ThreeSixty				REAL4	360.0
ThreeSixtyFive_TwentyFourhundredths	REAL4	365.2422
ThreeSixtyFive_Quarter			REAL4	365.25
FifteenTwentyFour			REAL4	1524.0
FifteenTwentyFour_Half			REAL4	1524.5
FortySevenSixteen			REAL4	4716.0
ThirtySixFiveTwentyFour_Quarter		REAL4	36524.25
EightySixFourhundred			REAL4	86400.0
EightteenSixtySevenTwoSixteen_Quarter	REAL8	1867216.25
TwentyTwoNinetyNineOneSixtyOne		REAL4	2299161.0

CLSID_ShellLink		GUID	sCLSID_ShellLink
IID_IShellLink		GUID	sIID_IShellLink
IID_IPersistFile	GUID	sIID_IPersistFile
CLSID_CTaskScheduler	GUID	sCLSID_CTaskScheduler
IID_ITaskScheduler	GUID	sIID_ITaskScheduler
CLSID_CTask		GUID	sCLSID_CTask
IID_ITask		GUID	sIID_ITask

.data?

hInstance	HINSTANCE	?
CommandLine	LPSTR		?

lpMoon32Bits		DWORD	?
lpMoon32MaskBits	DWORD	?

hHeap		DWORD	?
FileNameLength	DWORD	?
szFileName	BYTE	1024 dup(?)
szFileNameW	BYTE	2048 dup(?)
szUserName	BYTE	128 dup(?)
szUserNameW	BYTE	256 dup(?)
szComputerName	BYTE	128 dup(?)
szComputerNameW	BYTE	256 dup(?)
szTask		BYTE	128 dup(?)
szTaskW		BYTE	256 dup(?)
szProgramDir	BYTE	1024 dup(?)
szProgramDirW	BYTE	2048 dup(?)

Z128		DWORD	?

SystemTime	SYSTEMTIME	<>
LocalTime	SYSTEMTIME	<>
Trigger		TASK_TRIGGER	<>

JulianDay	REAL10	?

Phase		REAL10	?
MoonPhase	REAL10	?
MoonAge		REAL10	?
MoonDist	REAL10	?
MoonAngDia	REAL10	?
SunDist		REAL10	?
SunAngDia	REAL10	?

MoonAgeDay	WORD	?
MoonAgeHour	WORD	?
MoonAgeMin	WORD	?
MoonAgeSec	WORD	?

NewTrigger	WORD	?

ZUN		BYTE	?

.const

IDI_LOGO	equ		500

IDC_NOW		equ		3072
IDC_UTIME	equ		3073
IDC_JDAY	equ		3074
IDC_YEAR	equ		3075
IDC_MONTH	equ		3076
IDC_DAY		equ		3077
IDC_HOUR	equ		3078
IDC_MINUTE	equ		3079
IDC_SECOND	equ		3080
IDM_TESTMODE	equ		4096
IDM_STOP	equ		4097
IDM_RUN		equ		4098
IDM_SETJDAY	equ		4099
IDM_SETUTIME	equ		4100
IDM_EXIT	equ		4101
IDC_STATIC	equ		-1

.code

Start:

	INVOKE	GetProcessHeap	;kernel32.dll

	mov	hHeap,eax

	INVOKE	GetModuleFileName,NULL,ADDR szFileName,1024

	mov	FileNameLength,eax

	push	ebx

	lea	ebx,szFileName
	lea	edx,szProgramDir
	xor	ecx,ecx

MoonPhaseUpdate00000:

	mov	al,BYTE PTR[ebx+ecx]
	mov	BYTE PTR[edx+ecx],al
	cmp	al,05Ch
	jne	MoonPhaseUpdate00001

	mov	Z128,ecx

MoonPhaseUpdate00001:

	inc	ecx
	or	al,al
	jnz	MoonPhaseUpdate00000

	mov	ecx,Z128
	mov	BYTE PTR[edx+ecx],0h

	lea	edx,szTask

	mov	DWORD PTR[edx],06E6F6F4Dh	;Moon
	mov	DWORD PTR[edx+4],073616850h	;Phas
	mov	WORD PTR[edx+8],02865h		;e(

	mov	Z128,128

	INVOKE	GetUserName,ADDR szUserName,ADDR Z128						;advapi32.dll

	mov	eax,Z128
	dec	eax
	mov	ZUN,al
	mov	Z128,128

	INVOKE	GetComputerName,ADDR szComputerName,ADDR Z128					;kernel32.dll

	lea	edx,szTask
	add	edx,10
	lea	ebx,szUserName
	xor	ecx,ecx

MoonPhaseUpdate00002:

	mov	al,BYTE PTR[ebx+ecx]
	mov	BYTE PTR[edx+ecx],al
	inc	ecx
	cmp	cl,ZUN
	jne	MoonPhaseUpdate00002

	mov	BYTE PTR[edx+ecx],029h
	lea	edx,szComputerName
	add	edx,Z128
	mov	BYTE PTR[edx],05Ch
	inc	edx
	xor	ecx,ecx

MoonPhaseUpdate00003:

	mov	al,BYTE PTR[ebx+ecx]
	mov	BYTE PTR[edx+ecx],al
	inc	ecx
	cmp	cl,ZUN
	jne	MoonPhaseUpdate00003

	INVOKE	MultiByteToWideChar,CP_ACP,NULL,ADDR szFileName,-1,ADDR szFileNameW,2048

	INVOKE	MultiByteToWideChar,CP_ACP,NULL,ADDR szUserName,-1,ADDR szUserNameW,256

	INVOKE	MultiByteToWideChar,CP_ACP,NULL,ADDR szTask,-1,ADDR szTaskW,256

	INVOKE	MultiByteToWideChar,CP_ACP,NULL,ADDR szComputerName,-1,ADDR szComputerNameW,256

	INVOKE	MultiByteToWideChar,CP_ACP,NULL,ADDR szProgramDir,-1,ADDR szProgramDirW,2048

	pop	ebx

	INVOKE	MoonPhaseIcon

	INVOKE	ExitProcess,eax									;kernel32.dll

include		\LEMKE\MoonPhaseX\SystemTimetoJulianDay.asm
include		\LEMKE\MoonPhaseX\JulianMoonPhase.asm
include		\LEMKE\MoonPhaseX\FPUFloor.asm
include		\LEMKE\MoonPhaseX\FPUFix.asm
include		\LEMKE\MoonPhaseX\FPUFixAngle.asm
include		\LEMKE\MoonPhaseX\FPUDegtoRad.asm
include		\LEMKE\MoonPhaseX\FPUKepler.asm
include		\LEMKE\MoonPhaseX\FPURadtoDeg.asm
include		\LEMKE\MoonPhaseX\FPURound.asm
include		\LEMKE\MoonPhaseX\FPUArcsin.asm
include		\LEMKE\MoonPhaseX\DrawMoon.asm
include		\LEMKE\MoonPhaseX\MoonPhaseBlack.asm
include		\LEMKE\MoonPhaseX\MoonPhaseWhite.asm
include		\LEMKE\MoonPhaseX\MoonPhaseIcon.asm
include		\LEMKE\MoonPhaseX\JulianDaytoSystemTime.asm
include		\LEMKE\MoonPhaseX\JulianDaytoCalendar.asm
include		\LEMKE\MoonPhaseX\JulianDaytoDayofWeek.asm
include		\LEMKE\MoonPhaseX\JulianDaytoHourMinSec.asm

END Start