DrawMoon PROC dwBlackWhite:DWORD
	LOCAL	content[108]:BYTE
	LOCAL	dwRightx:DWORD
	LOCAL	dwLeftx:DWORD
	LOCAL	dwint:DWORD
	LOCAL	dwOffset:DWORD
	LOCAL	dwPh:DWORD

	mov	dwOffset,16
	mov	dwint,0

	fsave	content

	fld	Phase		;st=Phase
	fcom	Half		;st=Phase

	fstsw	ax		;retrieve exception flags from FPU
	fwait
	sahf			;transfer to the CPU flags

	jc	DrawMoon00000

	mov	dwPh,1
	fld1
	fsubr

	jmp	DrawMoon00001

DrawMoon00000:

	mov	dwPh,0

DrawMoon00001:

	fcom	Onehundredth	;st=Phase

	fstsw	ax		;retrieve exception flags from FPU
	fwait
	sahf			;transfer to the CPU flags

	jc	DrawMoon00011

	fldpi			;st=pi,st(1)=Phase
	fadd	st,st
	fmul			;st=2*pi*Phase
	fcos			;st=xscale=cos(2*pi*Phase)
	fld	Fifteen_Half	;st=Radius,st(1)=xscale
	fld	Onetenth

DrawMoon00002:

	fld	st		;st=i,st(1)=i,st(2)=Radius,st(3)=xscale
	fdiv	st,st(2)	;st=i/Radius,st(1)=i,st(2)=Radius,st(3)=xscale

	INVOKE	FPUArcsin	;st=asin(i/Radius),st(1)=i,st(2)=Radius,st(3)=xscale

	fcos			;st=cos(asin(i/Radius)),st(1)=i,st(2)=Radius,st(3)=xscale
	fmul	st,st(2)	;st=cp=Radius*cos(asin(i/Radius)),st(1)=i,st(2)=Radius,st(3)=xscale
	fmul	st,st(3)	;st=xscale*cp,st(1)=i,st(2)=Radius,st(3)=xscale
	fadd	Sixteen		;st=Center+xscale*cp,st(1)=i,st(2)=Radius,st(3)=xscale

	INVOKE	FPUFix		;st=int(Center+-xscale*cp),st(1)=cp,st(2)=i,st(3)=Radius,st(4)=xscale

	fistp	dwLeftx		;st=i,st(1)=Radius,st(2)=xscale
	fwait

	mov	eax,dwint
	add	eax,dwOffset
	cmp	dwPh,0
	mov	edx,32
	je	DrawMoon00003

	sub	edx,dwLeftx
	jmp	DrawMoon00004

DrawMoon00003:

	xor	edx,edx

DrawMoon00004:

	cmp	dwBlackWhite,BLACKNESS
	jne	DrawMoon00005

	INVOKE	MoonPhaseBlack,edx,eax,dwLeftx

	jmp	DrawMoon00006

DrawMoon00005:

	INVOKE	MoonPhaseWhite,edx,eax,dwLeftx

DrawMoon00006:

	mov	eax,dwOffset
	dec	eax
	sub	eax,dwint
	cmp	dwPh,0
	mov	edx,32
	je	DrawMoon00007

	sub	edx,dwLeftx
	jmp	DrawMoon00008

DrawMoon00007:

	xor	edx,edx

DrawMoon00008:

	cmp	dwBlackWhite,BLACKNESS
	jne	DrawMoon00009

	INVOKE	MoonPhaseBlack,edx,eax,dwLeftx

	jmp	DrawMoon00010

DrawMoon00009:

	INVOKE	MoonPhaseWhite,edx,eax,dwLeftx

DrawMoon00010:

	fld1			;st=1.0,st(1)=i,st(2)=Radius,st(3)=xscale
	fadd			;st=i=i+1,st(1)=Radius,st(2)=xscale

	inc	dwint
	cmp	dwint,16
	jb	DrawMoon00002

	jmp	DrawMoon00014

DrawMoon00011:

	cmp	dwBlackWhite,BLACKNESS
	jne	DrawMoon00012

	INVOKE	MoonPhaseBlack,0,dwint,32

	jmp	DrawMoon00013

DrawMoon00012:

	INVOKE	MoonPhaseWhite,0,dwint,32

DrawMoon00013:

	inc	dwint
	cmp	dwint,32
	jb	DrawMoon00011

DrawMoon00014:

	frstor	content

	ret

DrawMoon ENDP
