FPUFloor PROC


	push	eax		;reserve space on CPU stack

	fstcw	[esp]		;get current control word
	fwait
	mov	ax,[esp]
	or	ax,0C00h	;code it for truncating

	push	eax

	fldcw	[esp]		;change rounding code of FPU to truncate

	ftst			;st=x
	fstsw	ax
	fwait
	sahf
	jp	FPUFloor00001

	jb	FPUFloor00000

	frndint			;st=floor(x)

	jmp	FPUFloor00001

FPUFloor00000:

	fld1			;st=1.0,st(1)=x
	fsubr			;st=1.0-x
	frndint			;st=int(1.0-x)
	fchs			;st=floor(x)

FPUFloor00001:

	pop	eax		;remove modified CW from CPU stack

	fldcw	[esp]		;load back the former control word
	fwait

	pop	eax		;clean CPU stack

	ret

FPUFloor ENDP