FPURound PROC

	push	eax		;reserve space on CPU stack

	fstcw	[esp]		;get current control word
	fwait
	mov	ax,[esp]
	and	ax,0F3FFh	;code it for rounding

	push	eax

	fldcw	[esp]		;change rounding code of FPU to round

	frndint			;st=round(x)

	pop	eax		;remove modified CW from CPU stack

	fldcw	[esp]		;load back the former control word
	fwait

	pop	eax		;clean CPU stack

	ret

FPURound ENDP